﻿
/* Déclaration des variables  */
var geocoder;
var map;
var infowindow = new google.maps.InfoWindow();
var marker;

function onLoad()
            {
                geocoder = new google.maps.Geocoder();
	            var mapElement = document.getElementById("map");
             if  ( coordinates.LAT  <= 90 ) {
                 LatLng = new google.maps.LatLng(coordinates.LAT, coordinates.LON);
		            zoom = 18 ;
             }else {
		            LatLng = new google.maps.LatLng(49, 3);
		            zoom = 3;
		        }
 


            /*
             MapTypeId.ROADMAP affiche un plan (de type carte routière).
             MapTypeId.SATELLITE affiche une vue satellite.
             MapTypeId.HYBRID affiche une vue mixte entre les deux précédentes.
             MapTypeId.TERRAIN affiche une vue du relief.
            */
 var mapOpts = {      
                    center:LatLng,
                    zoom:zoom,
		            mapTypeId: google.maps.MapTypeId.SATELLITE 
	            };
	
	            var map = new google.maps.Map( mapElement, mapOpts );

	      


         if (coordinates) 
	            var marker = new google.maps.Marker( { 
		            position: map.getCenter(),
		            map: map,
                    draggable: true 
		            });


                // Add dragging event listeners.    
                google.maps.event.addListener(marker,
        'dragstart',
        function () {
            updateMarkerAddress('Dragging...');
        });

        google.maps.event.addListener(marker,
            'drag',
            function () {
                updateMarkerStatus('Dragging...');
                updateMarkerPosition(marker.getPosition());
            }
            );

            google.maps.event.addListener(marker,
        'dragend',
        function () {
            updateMarkerStatus('Drag ended');
            geocodePosition(marker.getPosition());
           
            }
        );


		        // Update current position info.    
		       updateMarkerPosition(LatLng);
		       geocodePosition(LatLng);
	      
	            return false;
    

            function blowupUrl(theUrl) {
                var win = new Window({
                    title: document.title,
                    url: theUrl,
                    classname: "alphacube",
                    left: 0, top: 0,
                    width: "640", height: "480",
                    minimizable: false,
                    maximizable: false,
                    draggable: false,
                    resizable: true,
                    destroyOnClose: true,
                    hideEffect: Element.hide,
                    showEffectOptions: { duration: 1.5 }
                })
                win.setConstraint(true, { top: 20, left: 20, bottom: 30, right: 20 });
                win.maximize();
                win.showCenter(true, 20, 20);
              
            }





      infowindow = new google.maps.InfoWindow();

      function geocodePosition(pos) {
          m = typeof geocoder;
            if (m == "undefined" ) return;
        geocoder.geocode({      
                'latLng': pos    },
                function(responses) {      
                    if (responses && responses.length > 0) {        
                        updateMarkerAddress(responses[0].formatted_address);
                    } else {        
                        updateMarkerAddress('Cannot determine address at this location.');      
                      }    
                }); 
       }    
       
       function updateMarkerStatus(str) {    
                document.getElementById('markerStatus').innerHTML = str; 
        }    
        
        function updateMarkerPosition(latLng) {    
                document.Envoie.lat.value=latLng.lat() ;
                document.Envoie.lon.value = latLng.lng();
                
                }
           
           function updateMarkerAddress(str) {               
                 message =  str;
                 document.getElementById('markerAdress').innerHTML = str; 

            }


        }


 



      
  /* Initialisation de la carte  */
        function initialize() {
            geocoder = new google.maps.Geocoder();
            var latlng = new google.maps.LatLng(40.730885, -73.997383);
            var myOptions = {
                zoom: 8,
                center: latlng,
                mapTypeId: 'roadmap'
            }
            map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
        }


        /* Fonction de géocodage déclenchée en cliquant surle bouton "Geocoder"  */
        function codeAddress() {
            /* Récupération de la valeur de l'adresse saisie */
            var address = document.getElementById("match").value;
            /* Appel au service de geocodage avec l'adresse en paramètre */
            geocoder.geocode({ 'address': address }, function (results, status) {
                /* Si l'adresse a pu être géolocalisée */
                if (status == google.maps.GeocoderStatus.OK) {
                    /* Récupération de sa latitude et de sa longitude */
                    document.Envoie.lat.value = results[0].geometry.location.lat();
                    document.Envoie.lon.value = results[0].geometry.location.lng();
                    map.setCenter(results[0].geometry.location);
                    /* Affichage du marker */
                    var marker = new google.maps.Marker({
                        map: map,
                        position: results[0].geometry.location
                    });
                    /* Permet de supprimer le marker précédemment affiché */
                    markers.push(marker);
                    if (markers.length > 1)
                        markers[(i - 1)].setMap(null);
                    i++;
                } else {
                    alert("Le geocodage n\'a pu etre effectue pour la raison suivante: " + status);
                }
            });
        }



  /* Fonction de géocodage inversé  */
  function codeLatLng() {
   var lat = parseFloat(document.Envoie.lat.value);
   var lng = parseFloat(document.Envoie.lon.value);
   var latlng = new google.maps.LatLng(lat, lng);

   geocoder.geocode({ 'latLng': latlng },
              function(results, status) {
                    /* Si le géocodage inversé a réussi */
                    if (status == google.maps.GeocoderStatus.OK) {
                     if (results[1]) {
                        map.setZoom(11);
                        marker = new google.maps.Marker({
                        position: latlng,
                        map: map
                       });
      /* Affichage de l'infowindow sur le marker avec l'adresse récupérée */
      infowindow.setContent(results[1].formatted_address);
      infowindow.open(map, marker);
     }
    } else {
     alert("Le geocodage a echoue pour la raion suivante : " + status);
    }
   });
  }
 
